package com.ejie.ab79.service.preguntasRespuestas;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.dao.preguntasRespuestas.FicherosAdjExpDao;
import com.ejie.ab79.model.REST.servicioWeb.FicheroRespuestaExpediente;
import com.ejie.ab79.model.preguntasRespuestas.FicherosAdjExp;
import com.ejie.ab79.webservice.adaptadores.PIFAdaptador;
import com.ejie.ab79.webservice.adaptadores.ab61WebServiceAdaptador;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * FicherosAdjExpServiceImpl  
 * 
 *  
 */

@Service(value = "ficherosAdjExpService")
public class FicherosAdjExpServiceImpl implements FicherosAdjExpService {

	private static final Logger logger = LoggerFactory.getLogger(FicherosAdjExpServiceImpl.class);

	@Autowired
	private FicherosAdjExpDao ficherosAdjExpDao;

	@Autowired
	private ab61WebServiceAdaptador ab61WebServiceAdaptadorService;

	@Autowired
	private PIFAdaptador pifAdapterService;

	/**
	 * Inserts a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	@Transactional(rollbackFor = Throwable.class)
	public FicherosAdjExp add(FicherosAdjExp ficherosAdjExp) {
		return this.ficherosAdjExpDao.add(ficherosAdjExp);
	}

	/**
	 * Updates a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	@Transactional(rollbackFor = Throwable.class)
	public FicherosAdjExp update(FicherosAdjExp ficherosAdjExp) {
		return this.ficherosAdjExpDao.update(ficherosAdjExp);
	}

	/**
	 * Finds a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 * @return FicherosAdjExp
	 */
	public FicherosAdjExp find(FicherosAdjExp ficherosAdjExp) {
		return (FicherosAdjExp) this.ficherosAdjExpDao.find(ficherosAdjExp);
	}

	/**
	 * Deletes a single row in the FicherosAdjExp table.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(FicherosAdjExp ficherosAdjExp) {
		this.ficherosAdjExpDao.remove(ficherosAdjExp);
	}

	/**
	 * Finds a list of rows in the FicherosAdjExp table.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<FicherosAdjExp>
	 */
	public List<FicherosAdjExp> findAll(FicherosAdjExp ficherosAdjExp, TableRequestDto tableRequestDto) {
		return (List<FicherosAdjExp>) this.ficherosAdjExpDao.findAll(ficherosAdjExp, tableRequestDto);
	}

	/**
	 * Finds rows in the FicherosAdjExp table using like.
	 *
	 * @param ficherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FicherosAdjExp>
	 */
	public List<FicherosAdjExp> findAllLike(FicherosAdjExp ficherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<FicherosAdjExp>) this.ficherosAdjExpDao.findAllLike(ficherosAdjExp, tableRequestDto, startsWith);
	}

	@Override
	public List<FicheroRespuestaExpediente> findFicherosREST(Integer idInspeccion) {
		return (List<FicheroRespuestaExpediente>) this.ficherosAdjExpDao.findFicherosREST(idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		this.ficherosAdjExpDao.removeMultiple(filterFicherosAdjExp, tableRequestDto, startsWith);
	}

	/**
	 * Filter method in the FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<FicherosAdjExp>
	 */
	public TableResponseDto<FicherosAdjExp> filter(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<FicherosAdjExp> listaFicherosAdjExp = this.ficherosAdjExpDao.findAllLike(filterFicherosAdjExp,
				tableRequestDto, false);
		Long recordNum = this.ficherosAdjExpDao
				.findAllLikeCount(filterFicherosAdjExp != null ? filterFicherosAdjExp : new FicherosAdjExp(), false);

		TableResponseDto<FicherosAdjExp> usuarioDto = new TableResponseDto<FicherosAdjExp>(tableRequestDto, recordNum,
				listaFicherosAdjExp);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<FicherosAdjExp>> reorderSelection = this.ficherosAdjExpDao
					.reorderSelection(filterFicherosAdjExp, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<FicherosAdjExp>> reorderSeeker = this.ficherosAdjExpDao
					.reorderSelection(filterFicherosAdjExp, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;
	}

	/**
	 * Searches rows in the FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param searchFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FicherosAdjExp>>
	 */
	public List<TableRowDto<FicherosAdjExp>> search(FicherosAdjExp filterFicherosAdjExp,
			FicherosAdjExp searchFicherosAdjExp, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.ficherosAdjExpDao.search(filterFicherosAdjExp, searchFicherosAdjExp, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ficherosAdjExpDao.reorderSelection(filterFicherosAdjExp, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the FicherosAdjExp table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<JerarquiaDto<FicherosAdjExp>>
	 */
	public TableResponseDto<JerarquiaDto<FicherosAdjExp>> jerarquia(FicherosAdjExp filterFicherosAdjExp,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<FicherosAdjExp>> listaFicherosAdjExp = this.ficherosAdjExpDao
				.findAllLikeJerarquia(filterFicherosAdjExp, tableRequestDto);
		Long recordNum = this.ficherosAdjExpDao.findAllLikeCountJerarquia(filterFicherosAdjExp, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<FicherosAdjExp>>(tableRequestDto, recordNum, listaFicherosAdjExp);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the FicherosAdjExp
	 * table.
	 *
	 * @param filterFicherosAdjExp
	 *            FicherosAdjExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<FicherosAdjExp>>
	 */
	public TableResponseDto<JerarquiaDto<FicherosAdjExp>> jerarquiaChildren(FicherosAdjExp filterFicherosAdjExp,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<FicherosAdjExp>> tableResponseDto = new TableResponseDto<JerarquiaDto<FicherosAdjExp>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.ficherosAdjExpDao.findAllChild(filterFicherosAdjExp, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<FicherosAdjExp> getMultiple(FicherosAdjExp filterFicherosAdjExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ficherosAdjExpDao.getMultiple(filterFicherosAdjExp, tableRequestDto, startsWith);
	}

	/**
	 * Descarga el fichero seleccionado en la pestaña informe técnico
	 */
	public void descargaFicheros(Integer idFichero, HttpServletResponse response) throws IOException {

		FicherosAdjExp ficherosAdjExp = new FicherosAdjExp();
		ficherosAdjExp.setIdFicheroAdjExp(idFichero);

		FicherosAdjExp fichero = this.ficherosAdjExpDao.find(ficherosAdjExp);
		BufferedInputStream bIS = null;

		try {
			String pathPif = this.ab61WebServiceAdaptadorService.descargarDocumentoPid(fichero.getOidPid(),
					Constantes.CODIGO_APLICACION, Constantes.TIPO_URL_PARCIAL);

			if (!StringUtils.isEmpty(pathPif)) {
				response.setHeader("content-disposition",
						"attachment; filename=\"" + fichero.getNombreFicheroAdjunto() + "\"");
				bIS = new BufferedInputStream(this.pifAdapterService.getFile(pathPif));
				IOUtils.copy(bIS, response.getOutputStream());
				response.flushBuffer();
			}
			FicherosAdjExpServiceImpl.logger.debug("descargarDocumentoPid:" + pathPif);

		} catch (Exception e) {
			FicherosAdjExpServiceImpl.logger.error("descargarDocumentoPid - ERROR " + e.getMessage(), e);
		} finally {
			if (bIS != null) {
				bIS.close();
			}
		}

	}

}
